/************************************************************************************************
Name            : TestProcessAffiliationRulesBatch
Description     : Test class for ProcessAffiliationRulesBatch.
Author          : Raghvendra Rathore
************************************************************************************************/
@IsTest
public class TestProcessAffiliationRulesBatch{
    static testMethod void testExecuteException(){
        Alignment_Global_Settings__c setting = new Alignment_Global_Settings__c(Name = 'AffiliationHierarchyThreshold', Tree_Hierarchy_Sort_Field__c = 'five');
        insert setting;
        
        Organization_Master__c org = CallPlanTestDataFactory.createOrganizationMasterRecord();
        insert org;

        Country__c country = CallPlanTestDataFactory.createCountryMasterRecord(org.id);
        insert country;

        Geography_Type__c geotype = CallPlanTestDataFactory.createGeographyTypeRecord(country.id);
        insert geotype;

        Team__c baseTeam = CallPlanTestDataFactory.createTeam('Base');
        baseTeam.Country__c = country.id;
        insert baseTeam;

        Workspace__c wrkspc = CallPlanTestDataFactory.createWorkspace();
        wrkspc.Country__c = country.id;
        insert wrkspc;

        Scenario__c scenario = new Scenario__c();
        scenario.CR_Tracking__c = true;
        scenario.Scenario_Name__c = 'HTN_Q3';
        scenario.Workspace__c = wrkspc.id;
        scenario.Team_Name__c = baseTeam.id;
        scenario.Request_Process_Stage__c = SalesIQGlobalConstants.READY;     
        scenario.Scenario_Stage__c = SalesIQGlobalConstants.COLLABORATION;   
        scenario.Scenario_Status__c = 'Active';
        scenario.Enable_Affiliation_Based_Alignment__c = true;
        insert scenario;  

        Affiliation_Network__c affNet = new Affiliation_Network__c(Name = 'test aff');
        insert affNet;

        Team_Instance__c baseTeamInstance = CallPlanTestDataFactory.CreateTeamInstance(baseTeam,'Hybrid');        
        baseTeamInstance.Geography_Type_Name__c = geotype.id;
        baseTeamInstance.Allow_Account_Exclusion__c = true;
        baseTeamInstance.Scenario__c = scenario.id;
        baseTeamInstance.Restrict_Account_Affiliation__c = false;
        baseTeamInstance.Enable_Affiliation_Movement__c = false;
        baseTeamInstance.Affiliation_Network__c = affNet.Id;
        baseTeamInstance.Alignment_Type__c = 'Account';
        baseTeamInstance.EnableAccountSharing__c = false;
        insert baseTeamInstance;

        Position__c  parentParent = null;

        Position__c territory  = CallPlanTestDataFactory.createPosition(parentParent,baseTeam);
        territory.Team_Instance__c = baseTeamInstance.id;
        insert territory;

        Position_Team_Instance__c territoryTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(territory, parentParent, BaseTeamInstance);       
        insert territoryTeamInstance;

        Position__c destTerritory  = CallPlanTestDataFactory.createDestinationPosition(parentParent,baseTeam);
        destTerritory.Team_Instance__c = baseTeamInstance.id;
        insert destTerritory;

        Position_Team_Instance__c dstinationTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(destTerritory, parentParent, BaseTeamInstance);       
        insert dstinationTeamInstance;

        Account acc = new Account();
        acc.Name = '11788';
        acc.FirstName__c = 'Abby';
        acc.BillingCity='NJ';
        acc.BillingState='NY';
        acc.AccountNumber='11788';
        acc.type = 'HCA';
        acc.AccountType__c = 'Physician';
        acc.BillingPostalCode = '11788';
        acc.Speciality__c = '11788Oncology';
        acc.Alignment_Type__c = 'Direct Aligned';
        acc.BillingLatitude = 40.5571389900;
        acc.BillingLongitude = -74.2123329900;
        acc.External_Country_Id__c=country.id;
        //insert acc;

        Account acc2 = new Account();
        acc2.Name = '11789';
        acc2.FirstName__c = 'Abby';
        acc2.BillingCity='NJ';
        acc2.BillingState='NY';
        acc2.AccountNumber='11788';
        acc2.type = 'HCP';
        acc2.AccountType__c = 'Physician';
        acc2.BillingPostalCode = '11788';
        acc2.Speciality__c = '11788Oncology';
        acc2.Alignment_Type__c = 'Direct Aligned';
        acc2.BillingLatitude = 40.5571389900;
        acc2.BillingLongitude = -74.2123329900;
        acc2.External_Country_Id__c=country.id;
        //insert acc2;

        Account acc3 = new Account();
        acc3.Name = '11788';
        acc3.FirstName__c = 'Abby';
        acc3.BillingCity='NJ';
        acc3.BillingState='NY';
        acc3.AccountNumber='11780';
        acc3.type = 'HCP';
        acc3.AccountType__c = 'Physician';
        acc3.BillingPostalCode = '11788';
        acc3.Speciality__c = '11788Oncology';
        acc3.Alignment_Type__c = 'Direct Aligned';
        acc3.BillingLatitude = 40.5571389900;
        acc3.BillingLongitude = -74.2123329900;
        acc3.External_Country_Id__c=country.id;
        //insert acc3;

        list<Account> lstAllAccount = new list<Account>();
        lstAllAccount.add(acc);
        lstAllAccount.add(acc2);
        lstAllAccount.add(acc3);
        insert lstAllAccount;

        list<Account_Affiliation__c> accAffList = new list<Account_Affiliation__c>();
        accAffList.add(new Account_Affiliation__c(Affiliation_Network__c = affNet.Id, Account__c = acc.Id, Root_Account__c = acc.Id));
        accAffList.add(new Account_Affiliation__c(Affiliation_Network__c = affNet.Id, Account__c = acc3.Id, Parent_Account__c = acc2.Id, Root_Account__c = acc2.Id));
        accAffList.add(new Account_Affiliation__c(Affiliation_Network__c = affNet.Id, Account__c = acc3.Id, Parent_Account__c = acc.Id, Root_Account__c = acc.Id));
        insert accAffList;

        list<Position_Account__c> lstAllPositionAccount = new list<Position_Account__c>();

        Position_Account__c positionAcc2 = CallPlanTestDataFactory.createPositionAccount(acc2, destTerritory, baseTeamInstance, dstinationTeamInstance);
        lstAllPositionAccount.add(positionAcc2);

        Position_Account__c positionAcc3 = CallPlanTestDataFactory.createPositionAccount(acc3, territory, baseTeamInstance, territoryTeamInstance);
        lstAllPositionAccount.add(positionAcc3);

        insert lstAllPositionAccount;

        test.startTest();
            system.debug('@@@@ executeBatch for acc movement 1');
            database.executeBatch(new ProcessAffiliationRulesBatch(baseTeamInstance.Id,new set<Id>{acc3.Id}));
            system.debug('@@@@ executeBatch for acc sharing 3');
            database.executeBatch(new ProcessAffiliationRulesBatch(baseTeamInstance.Id,new list<Position_Account__c>{positionAcc3}, 'Add'));
        test.stopTest();
    }
    
    static testMethod void testExecute(){
        Alignment_Global_Settings__c setting = new Alignment_Global_Settings__c(Name = 'AffiliationHierarchyThreshold', Tree_Hierarchy_Sort_Field__c = '5');
        insert setting;
        
        Organization_Master__c org = CallPlanTestDataFactory.createOrganizationMasterRecord();
        insert org;

        Country__c country = CallPlanTestDataFactory.createCountryMasterRecord(org.id);
        insert country;

        Geography_Type__c geotype = CallPlanTestDataFactory.createGeographyTypeRecord(country.id);
        insert geotype;

        Team__c baseTeam = CallPlanTestDataFactory.createTeam('Base');
        baseTeam.Country__c = country.id;
        insert baseTeam;

        Workspace__c wrkspc = CallPlanTestDataFactory.createWorkspace();
        wrkspc.Country__c = country.id;
        insert wrkspc;

        Scenario__c scenario = new Scenario__c();
        scenario.CR_Tracking__c = true;
        scenario.Scenario_Name__c = 'HTN_Q3';
        scenario.Workspace__c = wrkspc.id;
        scenario.Team_Name__c = baseTeam.id;
        scenario.Request_Process_Stage__c = SalesIQGlobalConstants.READY;     
        scenario.Scenario_Stage__c = SalesIQGlobalConstants.COLLABORATION;   
        scenario.Scenario_Status__c = 'Active';
        scenario.Enable_Affiliation_Based_Alignment__c = true;
        insert scenario;  

        Affiliation_Network__c affNet = new Affiliation_Network__c(Name = 'test aff');
        insert affNet;

        Team_Instance__c baseTeamInstance = CallPlanTestDataFactory.CreateTeamInstance(baseTeam,'Hybrid');        
        baseTeamInstance.Geography_Type_Name__c = geotype.id;
        baseTeamInstance.Allow_Account_Exclusion__c = true;
        baseTeamInstance.Scenario__c = scenario.id;
        baseTeamInstance.Restrict_Account_Affiliation__c = false;
        baseTeamInstance.Enable_Affiliation_Movement__c = false;
        baseTeamInstance.Affiliation_Network__c = affNet.Id;
        baseTeamInstance.Alignment_Type__c = 'Account';
        baseTeamInstance.EnableAccountSharing__c = false;
        insert baseTeamInstance;

        Position__c  parentParent = null;

        Position__c territory  = CallPlanTestDataFactory.createPosition(parentParent,baseTeam);
        territory.Team_Instance__c = baseTeamInstance.id;
        insert territory;

        Position_Team_Instance__c territoryTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(territory, parentParent, BaseTeamInstance);       
        insert territoryTeamInstance;

        Position__c destTerritory  = CallPlanTestDataFactory.createDestinationPosition(parentParent,baseTeam);
        destTerritory.Team_Instance__c = baseTeamInstance.id;
        insert destTerritory;

        Position_Team_Instance__c dstinationTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(destTerritory, parentParent, BaseTeamInstance);       
        insert dstinationTeamInstance;

        Account acc = new Account();
        acc.Name = '11788';
        acc.FirstName__c = 'Abby';
        acc.BillingCity='NJ';
        acc.BillingState='NY';
        acc.AccountNumber='11788';
        acc.type = 'HCA';
        acc.AccountType__c = 'Physician';
        acc.BillingPostalCode = '11788';
        acc.Speciality__c = '11788Oncology';
        acc.Alignment_Type__c = 'Direct Aligned';
        acc.BillingLatitude = 40.5571389900;
        acc.BillingLongitude = -74.2123329900;
        acc.External_Country_Id__c=country.id;
        //insert acc;

        Account acc2 = new Account();
        acc2.Name = '11789';
        acc2.FirstName__c = 'Abby';
        acc2.BillingCity='NJ';
        acc2.BillingState='NY';
        acc2.AccountNumber='11788';
        acc2.type = 'HCP';
        acc2.AccountType__c = 'Physician';
        acc2.BillingPostalCode = '11788';
        acc2.Speciality__c = '11788Oncology';
        acc2.Alignment_Type__c = 'Direct Aligned';
        acc2.BillingLatitude = 40.5571389900;
        acc2.BillingLongitude = -74.2123329900;
        acc2.External_Country_Id__c=country.id;
        //insert acc2;

        Account acc3 = new Account();
        acc3.Name = '11788';
        acc3.FirstName__c = 'Abby';
        acc3.BillingCity='NJ';
        acc3.BillingState='NY';
        acc3.AccountNumber='11780';
        acc3.type = 'HCP';
        acc3.AccountType__c = 'Physician';
        acc3.BillingPostalCode = '11788';
        acc3.Speciality__c = '11788Oncology';
        acc3.Alignment_Type__c = 'Direct Aligned';
        acc3.BillingLatitude = 40.5571389900;
        acc3.BillingLongitude = -74.2123329900;
        acc3.External_Country_Id__c=country.id;
        //insert acc3;

        list<Account> lstAllAccount = new list<Account>();
        lstAllAccount.add(acc);
        lstAllAccount.add(acc2);
        lstAllAccount.add(acc3);
        insert lstAllAccount;

        list<Account_Affiliation__c> accAffList = new list<Account_Affiliation__c>();
        accAffList.add(new Account_Affiliation__c(Affiliation_Network__c = affNet.Id, Account__c = acc.Id, Root_Account__c = acc.Id, Is_Primary__c = true, Active__c = true));
        accAffList.add(new Account_Affiliation__c(Affiliation_Network__c = affNet.Id, Account__c = acc3.Id, Parent_Account__c = acc2.Id, Root_Account__c = acc2.Id, Is_Primary__c = true, Active__c = true));
        accAffList.add(new Account_Affiliation__c(Affiliation_Network__c = affNet.Id, Account__c = acc3.Id, Parent_Account__c = acc.Id, Root_Account__c = acc.Id, Is_Primary__c = true, Active__c = true));
        insert accAffList;

        list<Position_Account__c> lstAllPositionAccount = new list<Position_Account__c>();

        /*Position_Account__c positionAcc = CallPlanTestDataFactory.createPositionAccount(acc, territory, baseTeamInstance, territoryTeamInstance, new Team_Instance_Account__c());
        lstAllPositionAccount.add(positionAcc);*/

        Position_Account__c positionAcc2 = CallPlanTestDataFactory.createPositionAccount(acc2, destTerritory, baseTeamInstance, dstinationTeamInstance);
        lstAllPositionAccount.add(positionAcc2);

        Position_Account__c positionAcc3 = CallPlanTestDataFactory.createPositionAccount(acc3, territory, baseTeamInstance, territoryTeamInstance);
        lstAllPositionAccount.add(positionAcc3);

        insert lstAllPositionAccount;

        test.startTest();
            system.debug('@@@@ executeBatch for acc movement 1');
            database.executeBatch(new ProcessAffiliationRulesBatch(baseTeamInstance.Id,new set<Id>{acc3.Id}));
            system.debug('@@@@ executeBatch for acc sharing 1');
            database.executeBatch(new ProcessAffiliationRulesBatch(baseTeamInstance.Id,new list<Position_Account__c>{positionAcc3}, 'Add'));

            baseTeamInstance.EnableAccountSharing__c = true;
            update baseTeamInstance;
            system.debug('@@@@ executeBatch for acc movement 2');
            database.executeBatch(new ProcessAffiliationRulesBatch(baseTeamInstance.Id,new set<Id>{acc3.Id}));
            system.debug('@@@@ executeBatch for acc sharing 2');
            database.executeBatch(new ProcessAffiliationRulesBatch(baseTeamInstance.Id,new list<Position_Account__c>{positionAcc3}, 'Add'));

            Business_Rule_Type_Master__c BRMaster = new Business_Rule_Type_Master__c(Name = 'Affiliation');
            insert BRMaster;

            Business_Rules__c br = new Business_Rules__c();
            br.Name = 'br1';
            br.Business_Rule_Type_Master__c = BRMaster.Id;
            br.Scenario__c = scenario.Id;
            br.Geographic_Preference__c = 'Align in Geo';
            br.Rule_Type__c = 'Bottom Up';
            insert br;

            BR_JoinRule__c joinrule1 = new BR_JoinRule__c();
            joinrule1.Business_Rules__c = br.Id;
            joinrule1.Affiliation_Hierarchy__c = 'Child';
            joinrule1.where_display_expression__c = '( Type = \'HCP\' )';
            joinrule1.where_expression_source__c = '( Type = \'HCP\' )';
            insert joinrule1;

            BR_JoinRule__c joinrule2 = new BR_JoinRule__c();
            joinrule2.Business_Rules__c = br.Id;
            joinrule2.Affiliation_Hierarchy__c = 'Parent';
            joinrule2.where_display_expression__c = '( Type = \'HCA\' )';
            joinrule2.where_expression_source__c = '( Type = \'HCA\' )';
            insert joinrule2;

            Change_Request_Type__c objRequestType = CallPlanTestDataFactory.CreateAccountRequestType();
            insert objRequestType;

            list<CIM_Config__c> cimList = CallPlanTestDataFactory.createCIMCOnfig(objRequestType, baseTeamInstance,'Team_Instance_Geography__c');
            insert cimList;

            list<CIM_Position_Metric_Summary__c> allPostionSummary = new list<CIM_Position_Metric_Summary__c>();
            
            list<CIM_Position_Metric_Summary__c> sourceCIMSummary =  CallPlanTestDataFactory.createCIMMetricSummary(cimList,territoryTeamInstance,baseTeamInstance);
            allPostionSummary.addAll(sourceCIMSummary);

            list<CIM_Position_Metric_Summary__c> destCIMSummary =  CallPlanTestDataFactory.createCIMMetricSummary(cimList,dstinationTeamInstance,baseTeamInstance);
            allPostionSummary.addAll(destCIMSummary);

            insert allPostionSummary;

            system.debug('@@@@ executeBatch for acc movement 3');
            database.executeBatch(new ProcessAffiliationRulesBatch(baseTeamInstance.Id,new set<Id>{acc3.Id}));
            system.debug('@@@@ executeBatch for acc sharing 3');
            database.executeBatch(new ProcessAffiliationRulesBatch(baseTeamInstance.Id,new list<Position_Account__c>{positionAcc3}, 'Add'));
        test.stopTest();
    }

    static testMethod void testCheckAccountAlignmentType(){
        Organization_Master__c org = CallPlanTestDataFactory.createOrganizationMasterRecord();
        insert org;

        Country__c country = CallPlanTestDataFactory.createCountryMasterRecord(org.id);
        insert country;

        Geography_Type__c geotype = CallPlanTestDataFactory.createGeographyTypeRecord(country.id);
        insert geotype;

        Team__c baseTeam = CallPlanTestDataFactory.createTeam('Base');
        baseTeam.Country__c = country.id;
        insert baseTeam;

        Workspace__c wrkspc = CallPlanTestDataFactory.createWorkspace();
        wrkspc.Country__c = country.id;
        insert wrkspc;

        Scenario__c scenario = new Scenario__c();
        scenario.CR_Tracking__c = true;
        scenario.Scenario_Name__c = 'HTN_Q3';
        scenario.Workspace__c = wrkspc.id;
        scenario.Team_Name__c = baseTeam.id;
        scenario.Request_Process_Stage__c = SalesIQGlobalConstants.READY;     
        scenario.Scenario_Stage__c = SalesIQGlobalConstants.COLLABORATION;   
        scenario.Scenario_Status__c = 'Active';
        scenario.Enable_Affiliation_Based_Alignment__c = true;
        insert scenario;  

        Affiliation_Network__c affNet = new Affiliation_Network__c(Name = 'test aff');
        insert affNet;

        Team_Instance__c baseTeamInstance = CallPlanTestDataFactory.CreateTeamInstance(baseTeam,'Hybrid');        
        baseTeamInstance.Geography_Type_Name__c = geotype.id;
        baseTeamInstance.Allow_Account_Exclusion__c = true;
        baseTeamInstance.Scenario__c = scenario.id;
        baseTeamInstance.Restrict_Account_Affiliation__c = false;
        baseTeamInstance.Enable_Affiliation_Movement__c = false;
        baseTeamInstance.Affiliation_Network__c = affNet.Id;
        baseTeamInstance.Alignment_Type__c = 'Account';
        baseTeamInstance.EnableAccountSharing__c = true;
        insert baseTeamInstance;

        Position__c  parentParent = null;

        Position__c territory  = CallPlanTestDataFactory.createPosition(parentParent,baseTeam);
        territory.Team_Instance__c = baseTeamInstance.id;
        insert territory;

        Position_Team_Instance__c territoryTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(territory, parentParent, BaseTeamInstance);       
        insert territoryTeamInstance;

        Position__c destTerritory  = CallPlanTestDataFactory.createDestinationPosition(parentParent,baseTeam);
        destTerritory.Team_Instance__c = baseTeamInstance.id;
        insert destTerritory;

        Position_Team_Instance__c dstinationTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(destTerritory, parentParent, BaseTeamInstance);       
        insert dstinationTeamInstance;

        Account acc = new Account();
        acc.Name = '11788';
        acc.FirstName__c = 'Abby';
        acc.BillingCity='NJ';
        acc.BillingState='NY';
        acc.AccountNumber='11788';
        acc.type = 'HCA';
        acc.AccountType__c = 'Physician';
        acc.BillingPostalCode = '11788';
        acc.Speciality__c = '11788Oncology';
        acc.Alignment_Type__c = 'Direct Aligned';
        acc.BillingLatitude = 40.5571389900;
        acc.BillingLongitude = -74.2123329900;
        acc.External_Country_Id__c=country.id;
        //insert acc;

        Account acc2 = new Account();
        acc2.Name = '11789';
        acc2.FirstName__c = 'Abby';
        acc2.BillingCity='NJ';
        acc2.BillingState='NY';
        acc2.AccountNumber='11788';
        acc2.type = 'HCP';
        acc2.AccountType__c = 'Physician';
        acc2.BillingPostalCode = '11788';
        acc2.Speciality__c = '11788Oncology';
        acc2.Alignment_Type__c = 'Direct Aligned';
        acc2.BillingLatitude = 40.5571389900;
        acc2.BillingLongitude = -74.2123329900;
        acc2.External_Country_Id__c=country.id;
        //insert acc2;

        Account acc3 = new Account();
        acc3.Name = '11788';
        acc3.FirstName__c = 'Abby';
        acc3.BillingCity='NJ';
        acc3.BillingState='NY';
        acc3.AccountNumber='11780';
        acc3.type = 'HCP';
        acc3.AccountType__c = 'Physician';
        acc3.BillingPostalCode = '11788';
        acc3.Speciality__c = '11788Oncology';
        acc3.Alignment_Type__c = 'Direct Aligned';
        acc3.BillingLatitude = 40.5571389900;
        acc3.BillingLongitude = -74.2123329900;
        acc3.External_Country_Id__c=country.id;
        //insert acc3;

        list<Account> lstAllAccount = new list<Account>();
        lstAllAccount.add(acc);
        lstAllAccount.add(acc2);
        lstAllAccount.add(acc3);
        insert lstAllAccount;

        list<Account_Affiliation__c> accAffList = new list<Account_Affiliation__c>();
        accAffList.add(new Account_Affiliation__c(Affiliation_Network__c = affNet.Id, Account__c = acc.Id, Root_Account__c = acc.Id));
        accAffList.add(new Account_Affiliation__c(Affiliation_Network__c = affNet.Id, Account__c = acc3.Id, Parent_Account__c = acc2.Id, Root_Account__c = acc2.Id));
        accAffList.add(new Account_Affiliation__c(Affiliation_Network__c = affNet.Id, Account__c = acc3.Id, Parent_Account__c = acc.Id, Root_Account__c = acc.Id));
        insert accAffList;

        list<Position_Account__c> lstAllPositionAccount = new list<Position_Account__c>();

        /*Position_Account__c positionAcc = CallPlanTestDataFactory.createPositionAccount(acc, territory, baseTeamInstance, territoryTeamInstance, new Team_Instance_Account__c());
        lstAllPositionAccount.add(positionAcc);*/

        Position_Account__c positionAcc2 = CallPlanTestDataFactory.createPositionAccount(acc2, destTerritory, baseTeamInstance, dstinationTeamInstance);
        lstAllPositionAccount.add(positionAcc2);

        Position_Account__c positionAcc3 = CallPlanTestDataFactory.createPositionAccount(acc3, territory, baseTeamInstance, territoryTeamInstance);
        lstAllPositionAccount.add(positionAcc3);

        insert lstAllPositionAccount;

        Business_Rule_Type_Master__c BRMaster = new Business_Rule_Type_Master__c(Name = 'Affiliation');
        insert BRMaster;

        Business_Rules__c br = new Business_Rules__c();
        br.Name = 'br1';
        br.Business_Rule_Type_Master__c = BRMaster.Id;
        br.Scenario__c = scenario.Id;
        br.Geographic_Preference__c = 'Align in Geo';
        br.Rule_Type__c = 'Bottom Up';
        insert br;

        BR_JoinRule__c joinrule1 = new BR_JoinRule__c();
        joinrule1.Business_Rules__c = br.Id;
        joinrule1.Affiliation_Hierarchy__c = 'Child';
        joinrule1.where_display_expression__c = '( Type = \'HCP\' )';
        joinrule1.where_expression_source__c = '( Type = \'HCP\' )';
        insert joinrule1;

        BR_JoinRule__c joinrule2 = new BR_JoinRule__c();
        joinrule2.Business_Rules__c = br.Id;
        joinrule2.Affiliation_Hierarchy__c = 'Parent';
        joinrule2.where_display_expression__c = '( Type = \'HCA\' )';
        joinrule2.where_expression_source__c = '( Type = \'HCA\' )';
        insert joinrule2;

        Change_Request_Type__c objRequestType = CallPlanTestDataFactory.CreateAccountRequestType();
        insert objRequestType;

        list<CIM_Config__c> cimList = CallPlanTestDataFactory.createCIMCOnfig(objRequestType, baseTeamInstance,'Team_Instance_Geography__c');
        insert cimList;

        list<CIM_Position_Metric_Summary__c> allPostionSummary = new list<CIM_Position_Metric_Summary__c>();
        
        list<CIM_Position_Metric_Summary__c> sourceCIMSummary =  CallPlanTestDataFactory.createCIMMetricSummary(cimList,territoryTeamInstance,baseTeamInstance);
        allPostionSummary.addAll(sourceCIMSummary);

        list<CIM_Position_Metric_Summary__c> destCIMSummary =  CallPlanTestDataFactory.createCIMMetricSummary(cimList,dstinationTeamInstance,baseTeamInstance);
        allPostionSummary.addAll(destCIMSummary);

        insert allPostionSummary;

        test.startTest();
            ProcessAffiliationRulesBatch cons = new ProcessAffiliationRulesBatch(baseTeamInstance.Id, new list<Position_Account__c>{positionAcc3}, 'Add');
            cons.checkAccountAlignmentType(new list<Position_Account__c>{positionAcc3});
        test.stopTest();
    }

    static testMethod void testCreateExclulsionLogger(){
        Organization_Master__c org = CallPlanTestDataFactory.createOrganizationMasterRecord();
        insert org;

        Country__c country = CallPlanTestDataFactory.createCountryMasterRecord(org.id);
        insert country;

        Geography_Type__c geotype = CallPlanTestDataFactory.createGeographyTypeRecord(country.id);
        insert geotype;

        Team__c baseTeam = CallPlanTestDataFactory.createTeam('Base');
        baseTeam.Country__c = country.id;
        insert baseTeam;

        Workspace__c wrkspc = CallPlanTestDataFactory.createWorkspace();
        wrkspc.Country__c = country.id;
        insert wrkspc;

        Scenario__c scenario = new Scenario__c();
        scenario.CR_Tracking__c = true;
        scenario.Scenario_Name__c = 'HTN_Q3';
        scenario.Workspace__c = wrkspc.id;
        scenario.Team_Name__c = baseTeam.id;
        scenario.Request_Process_Stage__c = SalesIQGlobalConstants.READY;     
        scenario.Scenario_Stage__c = SalesIQGlobalConstants.COLLABORATION;   
        scenario.Scenario_Status__c = 'Active';
        scenario.Enable_Affiliation_Based_Alignment__c = true;
        insert scenario;  

        Affiliation_Network__c affNet = new Affiliation_Network__c(Name = 'test aff');
        insert affNet;

        Team_Instance__c baseTeamInstance = CallPlanTestDataFactory.CreateTeamInstance(baseTeam,'Hybrid');        
        baseTeamInstance.Geography_Type_Name__c = geotype.id;
        baseTeamInstance.Allow_Account_Exclusion__c = true;
        baseTeamInstance.Scenario__c = scenario.id;
        baseTeamInstance.Restrict_Account_Affiliation__c = false;
        baseTeamInstance.Enable_Affiliation_Movement__c = false;
        baseTeamInstance.Affiliation_Network__c = affNet.Id;
        baseTeamInstance.Alignment_Type__c = 'Account';
        baseTeamInstance.EnableAccountSharing__c = true;
        insert baseTeamInstance;

        Position__c  parentParent = null;

        Position__c territory  = CallPlanTestDataFactory.createPosition(parentParent,baseTeam);
        territory.Team_Instance__c = baseTeamInstance.id;
        insert territory;

        Position_Team_Instance__c territoryTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(territory, parentParent, BaseTeamInstance);       
        insert territoryTeamInstance;

        Position__c destTerritory  = CallPlanTestDataFactory.createDestinationPosition(parentParent,baseTeam);
        destTerritory.Team_Instance__c = baseTeamInstance.id;
        insert destTerritory;

        Position_Team_Instance__c dstinationTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(destTerritory, parentParent, BaseTeamInstance);       
        insert dstinationTeamInstance;

        Account acc = new Account();
        acc.Name = '11788';
        acc.FirstName__c = 'Abby';
        acc.BillingCity='NJ';
        acc.BillingState='NY';
        acc.AccountNumber='11788';
        acc.type = 'HCA';
        acc.AccountType__c = 'Physician';
        acc.BillingPostalCode = '11788';
        acc.Speciality__c = '11788Oncology';
        acc.Alignment_Type__c = 'Direct Aligned';
        acc.BillingLatitude = 40.5571389900;
        acc.BillingLongitude = -74.2123329900;
        acc.External_Country_Id__c=country.id;
        //insert acc;

        Account acc2 = new Account();
        acc2.Name = '11789';
        acc2.FirstName__c = 'Abby';
        acc2.BillingCity='NJ';
        acc2.BillingState='NY';
        acc2.AccountNumber='11788';
        acc2.type = 'HCP';
        acc2.AccountType__c = 'Physician';
        acc2.BillingPostalCode = '11788';
        acc2.Speciality__c = '11788Oncology';
        acc2.Alignment_Type__c = 'Direct Aligned';
        acc2.BillingLatitude = 40.5571389900;
        acc2.BillingLongitude = -74.2123329900;
        acc2.External_Country_Id__c=country.id;
        //insert acc2;

        Account acc3 = new Account();
        acc3.Name = '11788';
        acc3.FirstName__c = 'Abby';
        acc3.BillingCity='NJ';
        acc3.BillingState='NY';
        acc3.AccountNumber='11780';
        acc3.type = 'HCP';
        acc3.AccountType__c = 'Physician';
        acc3.BillingPostalCode = '11788';
        acc3.Speciality__c = '11788Oncology';
        acc3.Alignment_Type__c = 'Direct Aligned';
        acc3.BillingLatitude = 40.5571389900;
        acc3.BillingLongitude = -74.2123329900;
        acc3.External_Country_Id__c=country.id;
        //insert acc3;

        list<Account> lstAllAccount = new list<Account>();
        lstAllAccount.add(acc);
        lstAllAccount.add(acc2);
        lstAllAccount.add(acc3);
        insert lstAllAccount;

        list<Account_Affiliation__c> accAffList = new list<Account_Affiliation__c>();
        accAffList.add(new Account_Affiliation__c(Affiliation_Network__c = affNet.Id, Account__c = acc.Id, Root_Account__c = acc.Id));
        accAffList.add(new Account_Affiliation__c(Affiliation_Network__c = affNet.Id, Account__c = acc3.Id, Parent_Account__c = acc2.Id, Root_Account__c = acc2.Id));
        accAffList.add(new Account_Affiliation__c(Affiliation_Network__c = affNet.Id, Account__c = acc3.Id, Parent_Account__c = acc.Id, Root_Account__c = acc.Id));
        insert accAffList;

        list<Position_Account__c> lstAllPositionAccount = new list<Position_Account__c>();

        Position_Account__c positionAcc2 = CallPlanTestDataFactory.createPositionAccount(acc2, destTerritory, baseTeamInstance, dstinationTeamInstance);
        lstAllPositionAccount.add(positionAcc2);

        Position_Account__c positionAcc3 = CallPlanTestDataFactory.createPositionAccount(acc3, territory, baseTeamInstance, territoryTeamInstance);
        lstAllPositionAccount.add(positionAcc3);

        insert lstAllPositionAccount;

        Business_Rule_Type_Master__c BRMaster = new Business_Rule_Type_Master__c(Name = 'Affiliation');
        insert BRMaster;

        Business_Rules__c br = new Business_Rules__c();
        br.Name = 'br1';
        br.Business_Rule_Type_Master__c = BRMaster.Id;
        br.Scenario__c = scenario.Id;
        br.Geographic_Preference__c = 'Align in Geo';
        br.Rule_Type__c = 'Bottom Up';
        insert br;

        BR_JoinRule__c joinrule1 = new BR_JoinRule__c();
        joinrule1.Business_Rules__c = br.Id;
        joinrule1.Affiliation_Hierarchy__c = 'Child';
        joinrule1.where_display_expression__c = '( Type = \'HCP\' )';
        joinrule1.where_expression_source__c = '( Type = \'HCP\' )';
        insert joinrule1;

        BR_JoinRule__c joinrule2 = new BR_JoinRule__c();
        joinrule2.Business_Rules__c = br.Id;
        joinrule2.Affiliation_Hierarchy__c = 'Parent';
        joinrule2.where_display_expression__c = '( Type = \'HCA\' )';
        joinrule2.where_expression_source__c = '( Type = \'HCA\' )';
        insert joinrule2;

        Change_Request_Type__c objRequestType = CallPlanTestDataFactory.CreateAccountRequestType();
        insert objRequestType;

        list<CIM_Config__c> cimList = CallPlanTestDataFactory.createCIMCOnfig(objRequestType, baseTeamInstance,'Team_Instance_Geography__c');
        insert cimList;

        list<CIM_Position_Metric_Summary__c> allPostionSummary = new list<CIM_Position_Metric_Summary__c>();
        
        list<CIM_Position_Metric_Summary__c> sourceCIMSummary =  CallPlanTestDataFactory.createCIMMetricSummary(cimList,territoryTeamInstance,baseTeamInstance);
        allPostionSummary.addAll(sourceCIMSummary);

        list<CIM_Position_Metric_Summary__c> destCIMSummary =  CallPlanTestDataFactory.createCIMMetricSummary(cimList,dstinationTeamInstance,baseTeamInstance);
        allPostionSummary.addAll(destCIMSummary);

        insert allPostionSummary;

        CR_Account__c crAcc = new CR_Account__c();
        crAcc.Account__c = acc3.Id;
        crAcc.Destination_Position__c = destTerritory.Id;
        crAcc.Source_Position__c = territory.Id;
        insert crAcc;

        test.startTest();
            ProcessAffiliationRulesBatch cons = new ProcessAffiliationRulesBatch(baseTeamInstance.Id, new list<Position_Account__c>{positionAcc3}, 'Add');
            cons.createExclulsionLogger(new list<CR_Account__c>{crAcc}, 'dummy job id');
        test.stopTest();
    }
    
    static testMethod void testExecuteTopDown(){
        Alignment_Global_Settings__c setting = new Alignment_Global_Settings__c(Name = 'AffiliationHierarchyThreshold', Tree_Hierarchy_Sort_Field__c = '5');
        insert setting;
        
        Organization_Master__c org = CallPlanTestDataFactory.createOrganizationMasterRecord();
        insert org;

        Country__c country = CallPlanTestDataFactory.createCountryMasterRecord(org.id);
        insert country;

        Geography_Type__c geotype = CallPlanTestDataFactory.createGeographyTypeRecord(country.id);
        insert geotype;

        Team__c baseTeam = CallPlanTestDataFactory.createTeam('Base');
        baseTeam.Country__c = country.id;
        insert baseTeam;

        Workspace__c wrkspc = CallPlanTestDataFactory.createWorkspace();
        wrkspc.Country__c = country.id;
        insert wrkspc;

        Scenario__c scenario = new Scenario__c();
        scenario.CR_Tracking__c = true;
        scenario.Scenario_Name__c = 'HTN_Q3';
        scenario.Workspace__c = wrkspc.id;
        scenario.Team_Name__c = baseTeam.id;
        scenario.Request_Process_Stage__c = SalesIQGlobalConstants.READY;     
        scenario.Scenario_Stage__c = SalesIQGlobalConstants.COLLABORATION;   
        scenario.Scenario_Status__c = 'Active';
        scenario.Enable_Affiliation_Based_Alignment__c = true;
        insert scenario;  

        Affiliation_Network__c affNet = new Affiliation_Network__c(Name = 'test aff');
        insert affNet;

        Team_Instance__c baseTeamInstance = CallPlanTestDataFactory.CreateTeamInstance(baseTeam,'Hybrid');        
        baseTeamInstance.Geography_Type_Name__c = geotype.id;
        baseTeamInstance.Allow_Account_Exclusion__c = true;
        baseTeamInstance.Scenario__c = scenario.id;
        baseTeamInstance.Restrict_Account_Affiliation__c = false;
        baseTeamInstance.Enable_Affiliation_Movement__c = false;
        baseTeamInstance.Affiliation_Network__c = affNet.Id;
        baseTeamInstance.Alignment_Type__c = 'Account';
        baseTeamInstance.EnableAccountSharing__c = false;
        insert baseTeamInstance;

        Position__c  parentParent = null;

        Position__c territory  = CallPlanTestDataFactory.createPosition(parentParent,baseTeam);
        territory.Team_Instance__c = baseTeamInstance.id;
        insert territory;

        Position_Team_Instance__c territoryTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(territory, parentParent, BaseTeamInstance);       
        insert territoryTeamInstance;

        Position__c destTerritory  = CallPlanTestDataFactory.createDestinationPosition(parentParent,baseTeam);
        destTerritory.Team_Instance__c = baseTeamInstance.id;
        insert destTerritory;

        Position_Team_Instance__c dstinationTeamInstance = CallPlanTestDataFactory.CreatePosTeamInstance(destTerritory, parentParent, BaseTeamInstance);       
        insert dstinationTeamInstance;

        Account acc = new Account();
        acc.Name = '11788';
        acc.FirstName__c = 'Abby';
        acc.BillingCity='NJ';
        acc.BillingState='NY';
        acc.AccountNumber='11788';
        acc.type = 'HCA';
        acc.AccountType__c = 'Physician';
        acc.BillingPostalCode = '11788';
        acc.Speciality__c = '11788Oncology';
        acc.Alignment_Type__c = 'Direct Aligned';
        acc.BillingLatitude = 40.5571389900;
        acc.BillingLongitude = -74.2123329900;
        acc.External_Country_Id__c=country.id;
        //insert acc;

        Account acc2 = new Account();
        acc2.Name = '11789';
        acc2.FirstName__c = 'Abby';
        acc2.BillingCity='NJ';
        acc2.BillingState='NY';
        acc2.AccountNumber='11788';
        acc2.type = 'HCP';
        acc2.AccountType__c = 'Physician';
        acc2.BillingPostalCode = '11788';
        acc2.Speciality__c = '11788Oncology';
        acc2.Alignment_Type__c = 'Direct Aligned';
        acc2.BillingLatitude = 40.5571389900;
        acc2.BillingLongitude = -74.2123329900;
        acc2.External_Country_Id__c=country.id;
        //insert acc2;

        Account acc3 = new Account();
        acc3.Name = '11788';
        acc3.FirstName__c = 'Abby';
        acc3.BillingCity='NJ';
        acc3.BillingState='NY';
        acc3.AccountNumber='11780';
        acc3.type = 'HCP';
        acc3.AccountType__c = 'Physician';
        acc3.BillingPostalCode = '11788';
        acc3.Speciality__c = '11788Oncology';
        acc3.Alignment_Type__c = 'Direct Aligned';
        acc3.BillingLatitude = 40.5571389900;
        acc3.BillingLongitude = -74.2123329900;
        acc3.External_Country_Id__c=country.id;
        //insert acc3;

        list<Account> lstAllAccount = new list<Account>();
        lstAllAccount.add(acc);
        lstAllAccount.add(acc2);
        lstAllAccount.add(acc3);
        insert lstAllAccount;

        list<Account_Affiliation__c> accAffList = new list<Account_Affiliation__c>();
        accAffList.add(new Account_Affiliation__c(Affiliation_Network__c = affNet.Id, Account__c = acc.Id, Root_Account__c = acc.Id, Is_Primary__c = true, Active__c = true));
        accAffList.add(new Account_Affiliation__c(Affiliation_Network__c = affNet.Id, Account__c = acc3.Id, Parent_Account__c = acc.Id, Root_Account__c = acc.Id, Is_Primary__c = true, Active__c = true));
        accAffList.add(new Account_Affiliation__c(Affiliation_Network__c = affNet.Id, Account__c = acc3.Id, Parent_Account__c = acc.Id, Root_Account__c = acc.Id, Is_Primary__c = true, Active__c = true));
        insert accAffList;

        list<Position_Account__c> lstAllPositionAccount = new list<Position_Account__c>();

        Position_Account__c positionAcc = CallPlanTestDataFactory.createPositionAccount(acc, destTerritory, baseTeamInstance, territoryTeamInstance);
        lstAllPositionAccount.add(positionAcc);

        Position_Account__c positionAcc2 = CallPlanTestDataFactory.createPositionAccount(acc2, territory, baseTeamInstance, dstinationTeamInstance);
        positionAcc2.Affiliation_Based_Alignment__c = true;
        lstAllPositionAccount.add(positionAcc2);

        Position_Account__c positionAcc3 = CallPlanTestDataFactory.createPositionAccount(acc3, territory, baseTeamInstance, territoryTeamInstance);
        lstAllPositionAccount.add(positionAcc3);

        insert lstAllPositionAccount;

        test.startTest();
            system.debug('@@@@ executeBatch for acc movement 1');
            database.executeBatch(new ProcessAffiliationRulesBatch(baseTeamInstance.Id,new set<Id>{acc.Id}));
            system.debug('@@@@ executeBatch for acc sharing 1');
            database.executeBatch(new ProcessAffiliationRulesBatch(baseTeamInstance.Id,new list<Position_Account__c>{positionAcc}, 'Add'));

            baseTeamInstance.EnableAccountSharing__c = true;
            update baseTeamInstance;
            system.debug('@@@@ executeBatch for acc movement 2');
            database.executeBatch(new ProcessAffiliationRulesBatch(baseTeamInstance.Id,new set<Id>{acc.Id}));
            system.debug('@@@@ executeBatch for acc sharing 2');
            database.executeBatch(new ProcessAffiliationRulesBatch(baseTeamInstance.Id,new list<Position_Account__c>{positionAcc}, 'Add'));

            Business_Rule_Type_Master__c BRMaster = new Business_Rule_Type_Master__c(Name = 'Affiliation');
            insert BRMaster;

            Business_Rules__c br = new Business_Rules__c();
            br.Name = 'br1';
            br.Business_Rule_Type_Master__c = BRMaster.Id;
            br.Scenario__c = scenario.Id;
            br.Geographic_Preference__c = 'Align in Geo';
            br.Rule_Type__c = SalesIQGlobalConstants.AFF_RULE_TOP_DOWN;
            insert br;

            BR_JoinRule__c joinrule1 = new BR_JoinRule__c();
            joinrule1.Business_Rules__c = br.Id;
            joinrule1.Affiliation_Hierarchy__c = 'Child';
            joinrule1.where_display_expression__c = '( Type = \'HCP\' )';
            joinrule1.where_expression_source__c = '( Type = \'HCP\' )';
            insert joinrule1;

            BR_JoinRule__c joinrule2 = new BR_JoinRule__c();
            joinrule2.Business_Rules__c = br.Id;
            joinrule2.Affiliation_Hierarchy__c = 'Parent';
            joinrule2.where_display_expression__c = '( Type = \'HCA\' )';
            joinrule2.where_expression_source__c = '( Type = \'HCA\' )';
            insert joinrule2;

            Change_Request_Type__c objRequestType = CallPlanTestDataFactory.CreateAccountRequestType();
            insert objRequestType;

            list<CIM_Config__c> cimList = CallPlanTestDataFactory.createCIMCOnfig(objRequestType, baseTeamInstance,'Team_Instance_Geography__c');
            insert cimList;

            list<CIM_Position_Metric_Summary__c> allPostionSummary = new list<CIM_Position_Metric_Summary__c>();
            
            list<CIM_Position_Metric_Summary__c> sourceCIMSummary =  CallPlanTestDataFactory.createCIMMetricSummary(cimList,territoryTeamInstance,baseTeamInstance);
            allPostionSummary.addAll(sourceCIMSummary);

            list<CIM_Position_Metric_Summary__c> destCIMSummary =  CallPlanTestDataFactory.createCIMMetricSummary(cimList,dstinationTeamInstance,baseTeamInstance);
            allPostionSummary.addAll(destCIMSummary);

            insert allPostionSummary;

            system.debug('@@@@ executeBatch for acc movement 3');
            database.executeBatch(new ProcessAffiliationRulesBatch(baseTeamInstance.Id,new set<Id>{acc.Id}));
            system.debug('@@@@ executeBatch for acc sharing 3');
            database.executeBatch(new ProcessAffiliationRulesBatch(baseTeamInstance.Id,new list<Position_Account__c>{positionAcc}, 'Add'));
        test.stopTest();
    }
}